<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
    >
      <el-form-item label="姓名" prop="name">
        <el-input :disabled="formType === 'handle'" v-model="formData.name" placeholder="请输入姓名" />
      </el-form-item>
      <el-form-item label="企业名称" prop="enterpriseName">
        <el-input :disabled="formType === 'handle'" v-model="formData.enterpriseName" placeholder="请输入企业名称" />
      </el-form-item>
      <el-form-item label="联系方式" prop="phone">
        <el-input :disabled="formType === 'handle'" v-model="formData.phone" placeholder="请输入联系方式" />
      </el-form-item>
      <el-form-item label="状态" prop="status">
        <el-select :disabled="formType === 'handle'" v-model="formData.status" placeholder="请选择状态">
          <el-option
            v-for="dict in getStrDictOptions(DICT_TYPE.MENDUNER_HUNT_STATUS)"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="备注" prop="remark">
        <el-input v-model="formData.remark" type="textarea" rows="6" placeholder="请输入备注" />
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { getStrDictOptions, DICT_TYPE } from '@/utils/dict'
import { HuntApi, HuntVO } from '@/api/menduner/system/hunt'

/** 猎寻服务 表单 */
defineOptions({ name: 'HuntForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  name: undefined,
  enterpriseName: undefined,
  phone: undefined,
  status: undefined,
  remark: undefined
})
const formRules = reactive({
  name: [{ required: true, message: '姓名不能为空', trigger: 'blur' }],
  enterpriseName: [{ required: true, message: '企业名称不能为空', trigger: 'blur' }],
  phone: [{ required: true, message: '联系方式不能为空', trigger: 'blur' }],
  status: [{ required: true, message: '状态（0待处理|1已联系）不能为空', trigger: 'change' }]
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await HuntApi.getHunt(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as HuntVO
    if (formType.value === 'create') {
      await HuntApi.createHunt(data)
      message.success(t('common.createSuccess'))
    } else if (formType.value === 'handle') {
      await HuntApi.dealHunt({ id: formData.value.id, remark: formData.value.remark })
      message.success(t('sys.api.operationSuccess'))
    } else {
      await HuntApi.updateHunt(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    name: undefined,
    enterpriseName: undefined,
    phone: undefined,
    status: undefined,
    remark: undefined
  }
  formRef.value?.resetFields()
}
</script>